package pencilbox.common.core;


/**
 * Տ̕ӂ̐l̍W\NX
 */
public class SideAddress implements Comparable<SideAddress> {
	
	public static final SideAddress NOWHERE = new SideAddress(-1, -1,-1);
	
	private int d;
	private int r;
	private int c;
	
	/**
	 * }XWƌӍW擾B
	 * @param pos }XW
	 * @param dir 
	 * @return ӍW
	 */
	public static SideAddress get(Address pos, int dir) {
		switch (dir) {
		case Direction.UP :
			return new SideAddress(Direction.HORIZ, pos.r()-1, pos.c());
		case Direction.LT :
			return new SideAddress(Direction.VERT, pos.r(), pos.c()-1);
		case Direction.DN :
			return new SideAddress(Direction.HORIZ, pos.r(), pos.c());
		case Direction.RT :
			return new SideAddress(Direction.VERT, pos.r(), pos.c());
		default :
			return SideAddress.NOWHERE;
		}
	}
	/**
	 * 
	 */
	public SideAddress() {
		this(0, 0, 0);
	}

	/**
	 * @param pos
	 */
	public SideAddress(SideAddress pos) {
		this(pos.d, pos.r, pos.c);
	}

	/**
	 * @param d
	 * @param r
	 * @param c
	 */
	public SideAddress(int d, int r, int c) {
		this.d = d;
		this.r = r;
		this.c = c;
	}

	/**
	 * @return Returns the d.
	 */
	public int d() {
		return d;
	}

	/**
	 * @return Returns the r.
	 */
	public int r() {
		return r;
	}

	/**
	 * @return Returns the c.
	 */
	public int c() {
		return c;
	}

	/**
	 * @param d
	 * @param r
	 * @param c
	 */
	public void set(int d, int r, int c){
		this.d = d;
		this.r = r;
		this.c = c;
	}
	
	public void set(SideAddress pos) {
		this.d = pos.d();
		this.r = pos.r();
		this.c = pos.c();
	}

	public boolean equals(Object o) {
		if (!(o instanceof SideAddress))
			return false;
		SideAddress address = (SideAddress) o;
		if (address.r == r && address.c == c && address.d == d)
			return true;
		else
			return false;
	}
	
	public int hashCode() {
		return ((d * 1000) + r) * 1000 + c;
	}
	/**
	 * @return
	 */
	public boolean isNowhere() {
		return (r==-1 && c==-1);
	}
	/**
	 * 
	 */
	public void setNowhere() {
		d = 0;
		r = -1;
		c = -1;
	}
	/** 
	 * ̒`
	 * VERT O HORIZ D
	 * sW r OC
	 * sW΁CW c OD
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(SideAddress o) {
		if (this.d < o.d) return -1;
		else if (this.d > o.d) return 1;
		else {
			if (this.r < o.r) return -1;
			else if (this.r > o.r) return 1;
			else {
				if (this.r < o.r) return -1;
				if (this.c < o.c) return -1;
				else if (this.c > o.c) return 1;
				else return 0; 
			}
		}
	}
	
	public String toString(){
		return "["+d+","+r+","+c+"]";
	}

}
